<template>
  <button
    :class="[$style[theme], $style.buttonDefaults]"
    :disabled="disabled"
    @click="clickHandler"
  >
    <BaseIcon v-if="hasIcon" :name="icon"></BaseIcon>
    <div :class="$style.buttonText">
      <slot></slot>
    </div>
  </button>
</template>

<script lang="ts">
import Vue from "vue";
import BaseIcon from "@/components/base/BaseIcon";

export default Vue.extend({
  name: "BaseButton",
  components: {
    BaseIcon
  },
  props: {
    disabled: {
      type: Boolean,
      required: false,
      default: false
    },
    icon: {
      type: String,
      required: false,
      default: "plus"
    },
    theme: {
      type: String,
      required: false,
      default: "primary",
      validator: function(value) {
        const accepteableValues = [
          "primary",
          "transparentPrimaryBorder",
          "transparent",
          "dark"
        ];
        return accepteableValues.indexOf(value) !== -1;
      }
    }
  },
  data: function() {
    return {
      selectedOption: null
    };
  },
  computed: {
    hasIcon: function() {
      return this.icon && this.icon.length > 0;
    }
  },
  methods: {
    clickHandler: function() {
      this.$emit("onClick");
    }
  }
});
</script>

<style module lang="scss">
.transparent {
  composes: button--transparent;
}
.dark {
  composes: button--dark;
}
.primary {
  composes: button--primary;
}
.transparentPrimaryBorder {
  composes: button--transparent-primary-border;
}
.buttonText {
  margin-left: 0.5rem;
}

@media screen and (max-width: $device-size--mobile-large) {
  .buttonDefaults {
    width: 100%;
  }
}
</style>
